"use strict";

var _inherits = function (child, parent) {
  child.prototype = Object.create(parent && parent.prototype, {
    constructor: {
      value: child,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (parent) child.__proto__ = parent;
};

var Container = require("./container");

// CSS at-rule like “this.keyframes name { }”.
//
// Can contain declarations (like this.font-face or this.page) ot another rules.
var AtRule = function AtRule(defaults) {
  this.type = "atrule";
  Container.call(this, defaults);
};

_inherits(AtRule, Container);

// Stringify at-rule
AtRule.prototype.stringify = function (builder, semicolon) {
  var name = "@" + this.name;
  var params = this.params ? this.stringifyRaw("params") : "";

  if (typeof this.afterName != "undefined") {
    name += this.afterName;
  } else if (params) {
    name += " ";
  }

  if (this.nodes) {
    this.stringifyBlock(builder, name + params);
  } else {
    var before = this.style("before");
    if (before) builder(before);
    var end = (this.between || "") + (semicolon ? ";" : "");
    builder(name + params + end, this);
  }
};

// Hack to mark, that at-rule contains children
AtRule.prototype.append = function (child) {
  if (!this.nodes) this.nodes = [];
  return Container.prototype.append.call(this, child);
};

// Hack to mark, that at-rule contains children
AtRule.prototype.prepend = function (child) {
  if (!this.nodes) this.nodes = [];
  return Container.prototype.prepend.call(this, child);
};

// Hack to mark, that at-rule contains children
AtRule.prototype.insertBefore = function (exist, add) {
  if (!this.nodes) this.nodes = [];
  return Container.prototype.insertBefore.call(this, exist, add);
};

// Hack to mark, that at-rule contains children
AtRule.prototype.insertAfter = function (exist, add) {
  if (!this.nodes) this.nodes = [];
  return Container.prototype.insertAfter.call(this, exist, add);
};

module.exports = AtRule;