"use strict";

var _inherits = function (child, parent) {
  child.prototype = Object.create(parent && parent.prototype, {
    constructor: {
      value: child,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (parent) child.__proto__ = parent;
};

var Node = require("./node");

// CSS comment between declarations or rules
var Comment = function Comment(defaults) {
  this.type = "comment";
  Node.call(this, defaults);
};

_inherits(Comment, Node);

// Stringify declaration
Comment.prototype.stringify = function (builder) {
  var before = this.style("before");
  if (before) builder(before);
  var left = this.style("left", "commentLeft");
  var right = this.style("right", "commentRight");
  builder("/*" + left + this.text + right + "*/", this);
};

module.exports = Comment;