"use strict";

var _inherits = function (child, parent) {
  child.prototype = Object.create(parent && parent.prototype, {
    constructor: {
      value: child,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (parent) child.__proto__ = parent;
};

var Node = require("./node");
var vendor = require("./vendor");

// CSS declaration like “color: black” in rules
var Declaration = function Declaration(defaults) {
  this.type = "decl";
  Node.call(this, defaults);
};

_inherits(Declaration, Node);

// Stringify declaration
Declaration.prototype.stringify = function (builder, semicolon) {
  var before = this.style("before");
  if (before) builder(before);

  var between = this.style("between", "colon");
  var string = this.prop + between + this.stringifyRaw("value");

  if (this.important) {
    string += this._important || " !important";
  }

  if (semicolon) string += ";";
  builder(string, this);
};

module.exports = Declaration;