"use strict";

var _prototypeProperties = function (child, staticProps, instanceProps) {
  if (staticProps) Object.defineProperties(child, staticProps);
  if (instanceProps) Object.defineProperties(child.prototype, instanceProps);
};

var _inherits = function (child, parent) {
  child.prototype = Object.create(parent && parent.prototype, {
    constructor: {
      value: child,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (parent) child.__proto__ = parent;
};

var Container = require("./container");
var Declaration = require("./declaration");
var list = require("./list");

// CSS rule like “a { }”
var Rule = function Rule(defaults) {
  this.type = "rule";
  this.nodes = [];
  Container.call(this, defaults);
};

_inherits(Rule, Container);

// Stringify rule
Rule.prototype.stringify = function (builder) {
  this.stringifyBlock(builder, this.stringifyRaw("selector"));
};

_prototypeProperties(Rule, null, {
  selectors: {

    // Shortcut to get selectors as array

    get: function () {
      return list.comma(this.selector);
    },
    set: function (values) {
      this.selector = values.join(", ");
    },
    enumerable: true
  }
});

module.exports = Rule;